% 
function [ActiveSet,ActiveSet_Throughput] = func_cell_selection_soft(SINR_ALL,BitRate_DL,BS_Utilization_DL)
%UNTITLED1 Summary of this function goes here
%  Detailed explanation goes here

ActiveSet(1:4) = 0;
ActiveSet_Throughput(1:4) = 0;
W_BS = 5*(10^6);
T_BS = 16;

MAX_NUM_BS = 7;
MAX_NUM_AP = 12;
MAX_NUM_ALL = MAX_NUM_BS + MAX_NUM_AP ;
BS_ALL(1:MAX_NUM_ALL) = 1:MAX_NUM_ALL;

Bandwidth_ALL(1:MAX_NUM_ALL) = 0;
Available_Bandwidth_ALL(1:MAX_NUM_ALL) = 0;
Achievable_Bandwidth_ALL(1:MAX_NUM_ALL) = 0;

Bandwidth_BS = 2*1000;
Bandwidth_AP = 11*1000;
Bandwidth_ALL(1:MAX_NUM_BS) = Bandwidth_BS;
Bandwidth_ALL((MAX_NUM_BS + 1):MAX_NUM_ALL) = Bandwidth_AP;
Available_Bandwidth_ALL = Bandwidth_ALL.*(1 - BS_Utilization_DL');

for i = 1:MAX_NUM_ALL
    if Available_Bandwidth_ALL(i) <= 0
        Achievable_Bandwidth_ALL(i) = 0;
    elseif Available_Bandwidth_ALL(i) > func_rate(SINR_ALL(i))
        Achievable_Bandwidth_ALL(i) = func_rate(SINR_ALL(i));
    else
        Achievable_Bandwidth_ALL(i) = Available_Bandwidth_ALL(i);
    end
end

Cost_ALL_SINR = T_BS * (2.^(func_cost(0)/W_BS) - 1);

BS_Low_Cost = BS_ALL(find(Cost_ALL_SINR == min(Cost_ALL_SINR)));

 if max(Achievable_Bandwidth_ALL(BS_Low_Cost)) >= BitRate_DL % if a AP can provide the user required bandwidth
     [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Low_Cost));
     ActiveSet(1) = BS_Low_Cost(Best_BS);
     ActiveSet_Throughput(1) = BitRate_DL;
 else
     if max(Achievable_Bandwidth_ALL(BS_Low_Cost)) > 0
         [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Low_Cost));
         ActiveSet(1) = BS_Low_Cost(Best_BS);
         ActiveSet_Throughput(1) = Best_BS_BW;
         BS_Candidate = BS_ALL(find(BS_ALL ~= ActiveSet(1)));
         if max(Achievable_Bandwidth_ALL(BS_Candidate)) >= (BitRate_DL - ActiveSet_Throughput(1))
             [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
             ActiveSet(2) = BS_Candidate(Best_BS);
             ActiveSet_Throughput(2) = BitRate_DL - ActiveSet_Throughput(1);
         else
             [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
             ActiveSet(2) = BS_Candidate(Best_BS);
             ActiveSet_Throughput(2) = Best_BS_BW;
             BS_Candidate = BS_ALL(find( (BS_ALL ~= ActiveSet(1)) & (BS_ALL ~= ActiveSet(2)) ));
             if max(Achievable_Bandwidth_ALL(BS_Candidate)) >= BitRate_DL - sum(ActiveSet_Throughput)
                 [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                 ActiveSet(3) = BS_Candidate(Best_BS);
                 ActiveSet_Throughput(3) = BitRate_DL - sum(ActiveSet_Throughput);
             else
                 [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                 ActiveSet(3) = BS_Candidate(Best_BS);
                 ActiveSet_Throughput(3) = Best_BS_BW;
                 BS_Candidate = BS_ALL(find( (BS_ALL ~= ActiveSet(1)) & (BS_ALL ~= ActiveSet(2)) & (BS_ALL ~= ActiveSet(3)) ));
                 if max(Achievable_Bandwidth_ALL(BS_Candidate)) >= BitRate_DL - sum(ActiveSet_Throughput)
                     [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                     ActiveSet(4) = BS_Candidate(Best_BS);
                     ActiveSet_Throughput(4) = BitRate_DL - sum(ActiveSet_Throughput);
                 else
                     [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                     ActiveSet(4) = BS_Candidate(Best_BS);
                     ActiveSet_Throughput(4) = Best_BS_BW;
                 end
             end
         end
     else
         if max(Achievable_Bandwidth_ALL) >= BitRate_DL
             [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL);
             ActiveSet(1) = Best_BS;
             ActiveSet_Throughput(1) = BitRate_DL;
         else
             [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL);
             ActiveSet(1) = Best_BS;
             ActiveSet_Throughput(1) = Best_BS_BW;
             BS_Candidate = BS_ALL(find(BS_ALL ~= ActiveSet(1)));
             if max(Achievable_Bandwidth_ALL(BS_Candidate)) >= BitRate_DL - ActiveSet_Throughput(1)
                 [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                 ActiveSet(2) = BS_Candidate(Best_BS);
                 ActiveSet_Throughput(2) = BitRate_DL - ActiveSet_Throughput(1);
             else
                 [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                 ActiveSet(2) = BS_Candidate(Best_BS);
                 ActiveSet_Throughput(2) = Best_BS_BW;
                 BS_Candidate = BS_ALL(find( (BS_ALL ~= ActiveSet(1)) & (BS_ALL ~= ActiveSet(2)) ));
                 if max(Achievable_Bandwidth_ALL(BS_Candidate)) >= BitRate_DL - sum(ActiveSet_Throughput)
                     [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                     ActiveSet(3) = BS_Candidate(Best_BS);
                     ActiveSet_Throughput(3) = BitRate_DL - sum(ActiveSet_Throughput);
                 else
                     [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                     ActiveSet(3) = BS_Candidate(Best_BS);
                     ActiveSet_Throughput(3) = Best_BS_BW;
                     BS_Candidate = BS_ALL(find( (BS_ALL ~= ActiveSet(1)) & (BS_ALL ~= ActiveSet(2)) & (BS_ALL ~= ActiveSet(3)) ));
                     if max(Achievable_Bandwidth_ALL(BS_Candidate)) >= BitRate_DL - sum(ActiveSet_Throughput)
                         [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                         ActiveSet(4) = BS_Candidate(Best_BS);
                         ActiveSet_Throughput(4) = BitRate_DL - sum(ActiveSet_Throughput);
                     else
                         [Best_BS_BW,Best_BS]= max(Achievable_Bandwidth_ALL(BS_Candidate));
                         ActiveSet(4) = BS_Candidate(Best_BS);
                         ActiveSet_Throughput(4) = Best_BS_BW;
                     end
                 end
             end
         end
     end

             
 end







