%clear all


MAX_NUM_UE = 150; %number of users
END_TIME = 1000; % unit is 100ms, which is 100s simulation time
MAX_SPEED = 22; %max moving speed is 80km/hour=22.2m/second
MAX_NUM_BS = 11;
MAX_NUM_AP = 12;
MAX_NUM_ALL = MAX_NUM_BS + MAX_NUM_AP ;

%TURN_SPEED = 0.05/10; % 0.005 turn per 100ms ,average direction&speed changing rate is 5 change per 100s
TURN_SPEED = 0.1/10; %average direction&speed changing rate is 10 change per 100s

PathLoss(1:MAX_NUM_BS,1:MAX_NUM_UE,1:END_TIME) = 0;
PathLoss_AP(1:MAX_NUM_AP,1:MAX_NUM_UE,1:END_TIME) = 0;
% PathLoss(1:MAX_NUM_BS,1:MAX_NUM_UE,1:(END_TIME/2)) = 0;
% PathLoss_2(1:MAX_NUM_BS,1:MAX_NUM_UE,1:(END_TIME/2)) = 0;
Step_x(1:MAX_NUM_UE,1:(4*END_TIME))= 0;
Step_y(1:MAX_NUM_UE,1:(4*END_TIME))= 0;
UE_x(1:MAX_NUM_UE,1:END_TIME) = 0;
UE_y(1:MAX_NUM_UE,1:END_TIME) = 0;
Distance(1:MAX_NUM_BS,1:MAX_NUM_UE) = 0;
Distance_AP(1:MAX_NUM_AP,1:MAX_NUM_UE) = 0;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% BS positions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CELL_R = 1200; %cell radium 800m

BS1_x = 0;
BS1_y = 0;

BS2_x = 0;
BS2_y = (3^(1/2)) * CELL_R;

BS3_x = 1.5 * CELL_R;
BS3_y = 0.5 * (3^(1/2)) * CELL_R;

BS4_x = 1.5 * CELL_R;
BS4_y = - BS3_y;

BS5_x = 0;
BS5_y = - BS2_y;

BS6_x = - BS3_x;
BS6_y = - BS3_y;

BS7_x = - BS3_x;
BS7_y = BS3_y;

BS8_x = BS3_x;
BS8_y = 3 * BS3_y;

BS9_x = BS8_x;
BS9_y = - BS8_y;

BS10_x = - BS8_x;
BS10_y = - BS8_y;

BS11_x = - BS8_x;
BS11_y = BS8_y;

BS_x = [BS1_x, BS2_x, BS3_x, BS4_x, BS5_x, BS6_x, BS7_x, BS8_x, BS9_x, BS10_x, BS11_x];
BS_y = [BS1_y, BS2_y, BS3_y, BS4_y, BS5_y, BS6_y, BS7_y, BS8_y, BS9_y, BS10_y, BS11_y];


AP1_x = (3/4) * CELL_R;
AP1_y = (3^(1/2))* 0.25 * CELL_R;

AP2_x = (3/4) * CELL_R;
AP2_y = - (3^(1/2))* 0.25 * CELL_R;

AP3_x = 0;
AP3_y = - (3^(1/2)) *0.5* CELL_R;

AP4_x = - (3/4) * CELL_R;
AP4_y = - (3^(1/2))* 0.25 * CELL_R;

AP5_x = - (3/4) * CELL_R;
AP5_y = (3^(1/2))* 0.25 * CELL_R;

AP6_x = 0;
AP6_y = (3^(1/2))*0.5* CELL_R;

AP7_x = 1.5 * CELL_R;
AP7_y = 0;

AP8_x = (3/4) * CELL_R;
AP8_y = - (3^(1/2))* 0.75 * CELL_R;

AP9_x = - (3/4) * CELL_R;
AP9_y = - (3^(1/2))* 0.75 * CELL_R;

AP10_x = - 1.5 * CELL_R;
AP10_y = 0;

AP11_x = - (3/4) * CELL_R;
AP11_y = (3^(1/2))* 0.75 * CELL_R;

AP12_x = (3/4) * CELL_R;
AP12_y = (3^(1/2))* 0.75 * CELL_R;

AP_x = [AP1_x, AP2_x, AP3_x, AP4_x, AP5_x, AP6_x, AP7_x, AP8_x, AP9_x, AP10_x, AP11_x, AP12_x];
AP_y = [AP1_y, AP2_y, AP3_y, AP4_y, AP5_y, AP6_y, AP7_y, AP8_y, AP9_y, AP10_y, AP11_y, AP12_y];

%AP_x = [AP1_x, AP2_x, AP3_x, AP4_x, AP5_x, AP6_x, AP7_x, AP8_x];
%AP_y = [AP1_y, AP2_y, AP3_y, AP4_y, AP5_y, AP6_y, AP7_y, AP8_y];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% UE initial positions (A or B)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%define simulation area in meter
MAX_x = BS3_x + CELL_R;
MAX_y = round(BS8_y);

% % A
% % user evenly distributed in all cells
UE_x(:,1) = unidrnd(2*2400, MAX_NUM_UE, 1) - 2400;
UE_y(:,1) = unidrnd(2*2400, MAX_NUM_UE, 1) - 2400;


% B
% more users in the middle

% UE_x(1:40,1) = unidrnd(1200, 40, 1) - 600;
% UE_y(1:40,1) = unidrnd(1200, 40, 1) - 600; 
% 
% 
% UE_x(41:70,1) = unidrnd(2200, 30, 1) - 1100;
% UE_y(41:70,1) = unidrnd(2200, 30, 1) - 1100; 
% 
% UE_x(71:MAX_NUM_UE,1) = unidrnd(2*1600, 30, 1) - 1600;
% UE_y(71:MAX_NUM_UE,1) = unidrnd(2*1600, 30, 1) - 1600; 

% UE_x(1:80,1) = unidrnd(1200, 80, 1) - 600;
% UE_y(1:80,1) = unidrnd(1200, 80, 1) - 600; 
% 
% 
% UE_x(81:140,1) = unidrnd(2200, 60, 1) - 1100;
% UE_y(81:140,1) = unidrnd(2200, 60, 1) - 1100; 
% 
% UE_x(141:MAX_NUM_UE,1) = unidrnd(2*1600, 60, 1) - 1600;
% UE_y(141:MAX_NUM_UE,1) = unidrnd(2*1600, 60, 1) - 1600; 


scatter(BS_x(1:7), BS_y(1:7),'^', 'k');
axis equal
for BS_ID=1:7
    text(BS_x(BS_ID), BS_y(BS_ID), [' BS' int2str(BS_ID)], 'FontSize',12 ); %show BS_ID
end 
hold on;

scatter(AP_x(1:12), AP_y(1:12),'^', 'k');
axis equal
for AP_ID=1:12
    text(AP_x(AP_ID), AP_y(AP_ID), [' AP' int2str(AP_ID)], 'FontSize',12 ); %show AP_ID
end 

scatter(UE_x(:,1), UE_y(:,1), '.', 'k');
%title(['Total User Number = ',int2str(MAX_NUM_UE)]);
axis equal


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% User movements
% unidrnd(x) randomly starts from 1 to x
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%change speed and direction after certain time
MEAN_TURN_NUM = round(END_TIME * TURN_SPEED);

for UE=1:MAX_NUM_UE
	turn_t = round(exprnd(1/TURN_SPEED,1,MEAN_TURN_NUM));
	t = 1;
	for turn=1:MEAN_TURN_NUM
		%Step_x(UE,t:(t+turn_t(turn))) = (unidrnd((2*MAX_SPEED+1), 1, 1)- (MAX_SPEED+1))/10;
		%Step_y(UE,t:(t+turn_t(turn))) = (unidrnd(round(2*((MAX_SPEED^2 - Step_x(UE,t).^2).^(1/2))+1), 1, 1)-((MAX_SPEED^2 - Step_x(UE,t).^2).^(1/2)+1))/10;
        
        %keep moving at max speed 
        Step_x(UE,t:(t+turn_t(turn))) = (unidrnd((2*MAX_SPEED+1), 1, 1)- (MAX_SPEED+1))/10;
        if unidrnd(2, 1, 1) == 1        
            Step_y(UE,t:(t+turn_t(turn))) = ((MAX_SPEED^2 - Step_x(UE,t).^2).^(1/2))/10;
        else
            Step_y(UE,t:(t+turn_t(turn))) = -((MAX_SPEED^2 - Step_x(UE,t).^2).^(1/2))/10;
        end
        		t = 1 + turn_t(turn);
	end
end
		
for t=1:END_TIME
	for UE=1:MAX_NUM_UE
		if (abs(UE_x(UE,t)) > 2400) || (abs(UE_y(UE,t)) > 2400)
			Step_x(UE,t)= -Step_x(UE,(t-1));
			Step_y(UE,t)= -Step_y(UE,(t-1));


			
			Step_x(UE,(t+1):END_TIME)= -Step_x(UE,(t+1):END_TIME);
			Step_y(UE,(t+1):END_TIME)= -Step_y(UE,(t+1):END_TIME);
		end
	end
		
	UE_x(:,t+1) = UE_x(:,t) + Step_x(:,t);
	UE_y(:,t+1) = UE_y(:,t) + Step_y(:,t);
end

for t=1:END_TIME
		
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Distance and PathLoss between BSs and UEs:  row: BSs, column: UEs
    % L(dB)=128.1 + 37.6*log10(R) + log(F), R in km, log(F) has normal ditribution
    % with deviation of 10dB
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Distance = ((repmat(UE_x(:,t)', 11, 1) - repmat(BS_x', 1, MAX_NUM_UE)).^2 + (repmat(UE_y(:,t)', 11, 1) - repmat(BS_y', 1, MAX_NUM_UE)).^2).^(1/2);
    
    Distance_AP = ((repmat(UE_x(:,t)', 12, 1) - repmat(AP_x', 1, MAX_NUM_UE)).^2 + (repmat(UE_y(:,t)', 12, 1) - repmat(AP_y', 1, MAX_NUM_UE)).^2).^(1/2);
    
    PathLoss(:,:,t) = 128.1 + 37.6 * log10(Distance / 1000) + normrnd(0,10,MAX_NUM_BS,MAX_NUM_UE); %pathloss from BSs to UEs in dB
    
    PathLoss_AP(:,:,t) = 128.1 + 37.6 * log10(Distance_AP / 1000) + 21*log10(2400/2000) + normrnd(0,10,MAX_NUM_AP,MAX_NUM_UE);
    		
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Save workspace
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% filename = ['D:\MATLAB7\work\batchtest\scene\scene-',int2str(MAX_NUM_UE),'-',int2str(END_TIME),'.mat']
% 
% save(filename, 'MAX_NUM_*', 'END_TIME', 'PathLoss','UE_x','UE_y','BS_x','BS_y' )



% %user randomly moving at all time
% for t=1:END_TIME
%     Step_x(:,t) = (unidrnd((2*MAX_SPEED+1), MAX_NUM_UE, 1)- (MAX_SPEED+1))/10;
%     Step_y(:,t) = (unidrnd(round(2*((MAX_SPEED^2 - Step_x(:,t).^2).^(1/2))+1), MAX_NUM_UE, 1)-((MAX_SPEED^2 - Step_x(:,t).^2).^(1/2)+1))/10;
%     UE_x(:,t+1) = UE_x(:,t) + Step_x(:,t);
%     UE_y(:,t+1) = UE_y(:,t) + Step_y(:,t);
%     
% end

