
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% System_Cost_Handover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Trigger = [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19];

Call_Arrival_Rate = [0.005 0.010 0.015 0.02 0.025 0.03 0.035 0.04 0.045 0.05 ];

Call_Arrival_Rate = [0.005 0.010 0.015 0.02 0.025 0.03 0.035 0.04 0.045 0.05 0.055 0.060 0.065 0.07 0.075 0.08 0.085 0.09 0.095 0.10];
%0.0003 

% Mean_System_Throughput_RSS_90 = mean(System_Throughput_RSS_90');
% Mean_System_Throughput_RSS_85 = mean(System_Throughput_RSS_85');
% Mean_System_Throughput_RSS_80 = mean(System_Throughput_RSS_80');
% Mean_System_Throughput_SINR = mean(System_Throughput_SINR');



subplot(2,2,2)
plot(Trigger, System_Mean_UE_Throughput_DL./1000,'-s','MarkerSize',3);
ylabel('Mean Throughput (kbps)');xlabel('Trigger Time (100ms)');

subplot(2,2,1)
plot(Trigger, System_Mean_Number_Handover,'-s','MarkerSize',3);
ylabel('Number of Handover');xlabel('Trigger Time (100ms)');

subplot(2,2,3)
plot(Trigger, System_Cost_Handover,'-s','MarkerSize',3);
ylabel('Handover Cost');xlabel('Trigger Time (100ms)');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Avg BS Throughput
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10]; %0.0003 


plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_NonAdaptive(1:10)./1024,'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_RSS_90(1:10)./1024,'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_RSS_85(1:10)./1024,'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_RSS_80(1:10)./1024,'--+','color','cyan','MarkerSize',4);
ylabel('BS Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','RSS-90','RSS-85','RSS-80',2);
xlim([0.005 0.05]);

plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_NonAdaptive(1:10)./1024,'--+', 'color','red','MarkerSize',4);
hold on
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U_0(1:10)./1024,'--o','color','red','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,1)./1024,'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,2)./1024,'-s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,3)./1024,'-d','color','cyan','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,4)./1024,'--d','MarkerSize',4);
%hold on
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Soft(1:10)./1024,'-o','MarkerSize',4);
ylabel('BS Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2',4);
xlim([0.005 0.05]);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Avg AP Throughput
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 

plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_NonAdaptive(1:10)./1024,'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_RSS_90(1:10)./1024,'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_RSS_85(1:10)./1024,'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_RSS_80(1:10)./1024,'--+','color','cyan','MarkerSize',4);
ylabel('AP Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','RSS-90','RSS-85','RSS-80',2);
xlim([0.005 0.05]);

plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_NonAdaptive(1:10)./1024,'--+', 'color','red','MarkerSize',4);
hold on
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U_0(1:10)./1024,'--o','color','red','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,1)./1024,'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,2)./1024,'-s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,3)./1024,'-d','color','cyan','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,4)./1024,'--d','MarkerSize',4);
%hold on
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Soft(1:10)./1024,'-o','MarkerSize',4);
ylabel('AP Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2',4);
xlim([0.005 0.05]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Avg Sys Throughput
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 


plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_NonAdaptive(1:10)./1024,'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_RSS_90(1:10)./1024,'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_RSS_85(1:10)./1024,'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_RSS_80(1:10)./1024,'--+','color','cyan','MarkerSize',4);
ylabel('Sys Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','RSS-90','RSS-85','RSS-80',2);
xlim([0.005 0.05]);


plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_NonAdaptive(1:10)./1024,'--x', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,1)./1024,'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,2)./1024,'-+','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,3)./1024,'-s','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,4)./1024,'-d','color','Magenta','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Soft(1:10)./1024,'-o','MarkerSize',4);
ylabel('Sys Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2','MASVH k=3',4);
xlim([0.005 0.05]);


plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_NonAdaptive(1:10)./1024,'--+', 'color','blue','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,2)./1024,'-s','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_Soft(1:10)./1024,'-d','color','red','MarkerSize',4);
ylabel('Sys Mean Throughput (Mbps)');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',4);
xlim([0.005 0.05]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Avg Sys Capacity Gain
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 

plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_NonAdaptive,'-x','MarkerSize',4);

plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(:,1)- System_Avg_Sys_Throughput_DL_NonAdaptive)*19/1000,'-o','MarkerSize',4);

hold on
%plot(Call_Arrival_Rate, System_Avg_Sys_Throughput_DL_Adaptive_U,'-v','MarkerSize',4);
plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(:,2)- System_Avg_Sys_Throughput_DL_NonAdaptive)*19/1000,'-d','MarkerSize',4);
plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(:,3)- System_Avg_Sys_Throughput_DL_NonAdaptive)*19/1000,'-^','MarkerSize',4);
plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(:,4)- System_Avg_Sys_Throughput_DL_NonAdaptive)*19/1000,'-v','MarkerSize',4);
%plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(:,5)- System_Avg_Sys_Throughput_DL_NonAdaptive)*19,'-v','MarkerSize',4);
ylabel('Sys Throughput Gain (Mbps)');xlabel('Arrival rate (sessions/second)');
legend('k=0','k=1','k=2','k=3',4);
xlim([0.005 0.05]);


plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,1)'-System_Avg_Sys_Throughput_DL_NonAdaptive(1:10))*19/1000,'--o','color','green','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,2)'-System_Avg_Sys_Throughput_DL_NonAdaptive(1:10))*19/1000,'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,3)'-System_Avg_Sys_Throughput_DL_NonAdaptive(1:10))*19/1000,'--+','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,4)'-System_Avg_Sys_Throughput_DL_NonAdaptive(1:10))*19/1000,'--d','color','Magenta','MarkerSize',4);
%plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,5)'-System_Avg_Sys_Throughput_DL_NonAdaptive(1:10))*19/1000,'--v','color','cyan','MarkerSize',4);
%plot(Call_Arrival_Rate, (System_Avg_Sys_Throughput_DL_Adaptive_Cost_U(1:10,6)'-System_Avg_Sys_Throughput_DL_NonAdaptive(1:10))*19/1000,'--^','color','cyan','MarkerSize',4);

ylabel('Sys Throughput Gain (Mbps)');xlabel('Arrival rate (sessions/second)');
legend('k=0','k=1','k=2','k=3',4);
xlim([0.005 0.05]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Avg Sys Dropping
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 


plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_NonAdaptive(1:10),'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_RSS_90(1:10),'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_RSS_85(1:10),'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_RSS_80(1:10),'--+','color','cyan','MarkerSize',4);
ylabel('Sys Dropping Probability');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','RSS-90','RSS-85','RSS-80',2);
xlim([0.005 0.05]);
ylim([0 1]);

plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_NonAdaptive(1:10),'--x', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Cost_U(1:10,1),'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Cost_U(1:10,2),'-+','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Cost_U(1:10,3),'-s','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Cost_U(1:10,4),'-d','color','magenta','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Soft(1:10),'-o','MarkerSize',4);
ylabel('Sys Dropping Probability');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2','MASVH k=3',2);
xlim([0.005 0.05]);
ylim([0 1]);

plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_NonAdaptive(1:10),'--+', 'color','blue','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Cost_U(1:10,2),'--s','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Soft(1:10),'-d','color','red','MarkerSize',4);
ylabel('Sys Dropping Probability');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',2);
xlim([0.005 0.05]);
ylim([0 0.05]);


plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_NonAdaptive(1:10),'--s','MarkerSize',3);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_RSS_90(1:10),'--^','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_RSS_85(1:10),'--d','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_RSS_80(1:10),'--v','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Cost_U(1:10),'-+','MarkerSize',3);
%hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Blocking_DL_Adaptive_Soft(1:10),'-o','MarkerSize',3);

ylabel('Sys Dropping Probability');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',2);
legend('MASVH','CAVSH',2);

ylim([0 0.25]);

xlim([0.005 0.05]);
%legend('Non-Adaptive','Adpative-Cost','Adpative-Cost b=1','Adpative-Cost b=2','Adpative-Cost b=3','Adpative-Cost b=4',4);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% System Cost Handover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 

plot(Call_Arrival_Rate, System_Avg_UE_Cost_NonAdaptive(1:10),'--x','color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Cost_U(1:10,1),'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Cost_U(1:10,2),'-+','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Cost_U(1:10,3),'-s','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Cost_U(1:10,4),'-d','color','Magenta','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Soft(1:10),'-o','MarkerSize',4);
ylabel('User Average Cost');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2','MASVH k=3',1);
xlim([0.005 0.05]);
ylim([0.44 0.52]);

plot(Call_Arrival_Rate, System_Avg_UE_Cost_NonAdaptive(1:10),'--+','color','blue','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Cost_U(1:10,2),'--s','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_UE_Cost_Adaptive_Soft(1:10),'-d','color','red','MarkerSize',4);
ylabel('User Average Cost');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',1);
xlim([0.005 0.05]);
ylim([0.39 0.54]);

% legend('Non-Adaptive','Adpative b=0','Adpative b=1','Adpative b=2','Adpative b=3',1);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% BS Utilization
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 

% Mean_System_Throughput_RSS_90 = mean(System_Throughput_RSS_90');
% Mean_System_Throughput_RSS_85 = mean(System_Throughput_RSS_85');
% Mean_System_Throughput_RSS_80 = mean(System_Throughput_RSS_80');
% Mean_System_Throughput_SINR = mean(System_Throughput_SINR');

plot(Call_Arrival_Rate, (System_Avg_BS_Throughput_DL_NonAdaptive(1:10)-200)./2048,'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_RSS_90(1:10)./2048,'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_RSS_85(1:10)./2048,'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_RSS_80(1:10)./2048,'--+','color','cyan','MarkerSize',4);
ylabel('BS Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','RSS-90','RSS-85','RSS-80',4);
xlim([0.005 0.05]);
ylim([0.3 1.1]);


plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_NonAdaptive(1:10)./2000,'--x', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,1)./2000,'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,2)./2000,'-+','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,3)./2000,'-s','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,4)./2000,'-d','color','Magenta','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Soft(1:10)./11000,'-+','color','cyan','MarkerSize',4);
ylabel('BS Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2','MASVH k=3',4);
xlim([0.005 0.05]);
ylim([0 1]);


plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_NonAdaptive(1:10)./2000,'--+', 'color','blue','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Cost_U(1:10,2)./2000,'--s','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Throughput_DL_Adaptive_Soft(1:10)./2000,'-d','color','red','MarkerSize',4);
ylabel('BS Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',2);
xlim([0.005 0.05]);
ylim([0 1]);


plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_NonAdaptive(1:10),'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_RSS_90(1:10),'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_RSS_85(1:10),'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_RSS_80(1:10),'--+','color','cyan','MarkerSize',4);
ylabel('BS Utilization');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','RSS-90','RSS-85','RSS-80',4);
xlim([0.005 0.05]);


plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Cost_U(1:10,1),'-o','color','yellow','MarkerSize',4);
hold on
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U_0(1:10)./2000,'--o','color','red','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Cost_U(1:10,2),'-s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Cost_U(1:10,3),'-d','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_NonAdaptive(1:10),'--+', 'color','red','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,4)./11000,'--+','color','cyan','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Soft(1:10)./11000,'-+','color','cyan','MarkerSize',4);
ylabel('BS Utilization');xlabel('Arrival rate (sessions/second)');
legend('MASVH k=0','MASVH k=1','MASVH k=2','CSVH',2);


plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_NonAdaptive(1:10),'-d','MarkerSize',3);
hold on
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_RSS_90(1:10),'--^','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_RSS_85(1:10),'--d','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_RSS_80(1:10),'--v','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Cost_U(1:10),'-+','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Soft(1:10),'-o','MarkerSize',3);
%plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_U,'-v','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Cost_U(:,2),'-d','MarkerSize',4);
ylabel('BS Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MSSVH','CAVSH',4);

xlim([0.005 0.05]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% AP Utilization
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 

% Mean_System_Throughput_RSS_90 = mean(System_Throughput_RSS_90');
% Mean_System_Throughput_RSS_85 = mean(System_Throughput_RSS_85');
% Mean_System_Throughput_RSS_80 = mean(System_Throughput_RSS_80');
% Mean_System_Throughput_SINR = mean(System_Throughput_SINR');
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_NonAdaptive(1:10)./11000,'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_RSS_90(1:10)./11000,'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_RSS_85(1:10)./11000,'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_RSS_80(1:10)./11000,'--+','color','cyan','MarkerSize',4);
ylabel('AP Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','RSS-90','RSS-85','RSS-80',2);
xlim([0.005 0.05]);

plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_NonAdaptive(1:10)./11000,'--x', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,1)./11000,'-o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,2)./11000,'-+','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,3)./11000,'-s','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,4)./11000,'-d','color','Magenta','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Soft(1:10)./11000,'-+','color','cyan','MarkerSize',4);
ylabel('AP Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH k=0','MASVH k=1','MASVH k=2','MASVH k=3',4);
xlim([0.005 0.05]);
ylim([0 1]);

plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_NonAdaptive(1:10)./11000,'--+', 'color','blue','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,2)./11000,'--s','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Soft(1:10)./11000,'-d','color','red','MarkerSize',4);
ylabel('AP Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',4);
xlim([0.005 0.05]);


plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_NonAdaptive(1:10),'-d', 'color','red','MarkerSize',4);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_RSS_90(1:10),'--o','color','green','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_RSS_85(1:10),'--s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_RSS_80(1:10),'--+','color','cyan','MarkerSize',4);
ylabel('AP Utilization');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('CSVH','RSS-90','RSS-85','RSS-80',2);
xlim([0.005 0.05]);

plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Cost_U(1:10,1),'-o','color','green','MarkerSize',4);
hold on
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U_0(1:10)./2000,'--o','color','red','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Cost_U(1:10,2),'-s','color','blue','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Cost_U(1:10,3),'-d','color','cyan','MarkerSize',4);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_NonAdaptive(1:10),'--+', 'color','red','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Cost_U(1:10,4)./11000,'--+','color','cyan','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Throughput_DL_Adaptive_Soft(1:10)./11000,'-+','color','cyan','MarkerSize',4);
ylabel('AP Utilization');xlabel('Arrival rate (sessions/second)');
% legend('CSVH','MASVH','CAVSH',4);
legend('MASVH k=0','MASVH k=1','MASVH k=2','CSVH',2);


plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_NonAdaptive(1:10),'-s','MarkerSize',3);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_RSS_90(1:10),'--^','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_RSS_85(1:10),'--d','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_RSS_80(1:10),'--v','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Cost_U(1:10),'-+','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Soft(1:10),'-o','MarkerSize',3);
%plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_U,'-v','MarkerSize',4);
%plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Cost_U(:,2),'-d','MarkerSize',4);
ylabel('AP Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',4);

xlim([0.005 0.05]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Sys Utilization
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Call_Arrival_Rate = [0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09 0.10 ]; %0.0003 

% Mean_System_Throughput_RSS_90 = mean(System_Throughput_RSS_90');
% Mean_System_Throughput_RSS_85 = mean(System_Throughput_RSS_85');
% Mean_System_Throughput_RSS_80 = mean(System_Throughput_RSS_80');
% Mean_System_Throughput_SINR = mean(System_Throughput_SINR');

plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_NonAdaptive(1:10),'-s','MarkerSize',3);
hold on
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_RSS_90(1:10),'--^','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_RSS_85(1:10),'--d','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_RSS_80(1:10),'--v','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_Adaptive_Cost_U(1:10),'-+','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_Adaptive_Soft(1:10),'-o','MarkerSize',3);
%plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_Adaptive_Cost_U(:,2),'-s','MarkerSize',4);
ylabel('Sys Utilization');xlabel('Arrival rate (sessions/second)');
legend('CSVH','MASVH','CAVSH',4);

xlim([0.005 0.05]);


plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Cost_U,'--+','MarkerSize',3);
hold on
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Cost_U,'--*','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_Adaptive_Cost_U,'--o','MarkerSize',3);


plot(Call_Arrival_Rate, System_Avg_BS_Utilization_DL_Adaptive_Soft,'-+','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_AP_Utilization_DL_Adaptive_Soft,'-*','MarkerSize',3);
plot(Call_Arrival_Rate, System_Avg_Sys_Utilization_DL_Adaptive_Soft,'-o','MarkerSize',3);

ylabel('Utilization');xlabel('Arrival rate (sessions/second)');
legend('MASVH-BS','MASVH-AP','MASVH-Sys','CAVSH-BS','CAVSH-AP','CAVSH-Sys',4);


