
ActiveSet_ALL(1:MAX_NUM_UE,1:4,1:END_TIME) = 0; 
ActiveSet_Throughput_ALL(1:MAX_NUM_UE,1:4,1:END_TIME) = 0; 
BS_Busy(1:MAX_NUM_ALL,1:END_TIME)= 0;
Number_Handover(1:MAX_NUM_UE) = 0;
UE_Cost_Handover(1:MAX_NUM_UE) = 0;


%define parameters
ChipRate = 3.84e6;
Pn_BS = 3.84e-14; %background noise power, NF=4dB
Pn_UE = 7.66e-14; %NF=7dB
ALPHA = 0.4;


%downlink
MAX_BS_txpower = 20; %43dBm=20W

BS_HSDPA_txpower (1:MAX_NUM_BS) = 0.5 * MAX_BS_txpower ; %each BS's HSDPA power, 10W or zero

BS_Pilot_txpower(1:MAX_NUM_BS) = 1; %pilot channel power 30dBm=1W
BS_Common_txpower(1:MAX_NUM_BS) = 1; %combined power of other common channels 30dBm=1W

UE_total_rxpower(1:MAX_NUM_UE) = 0;
UE_total_rxpower_AP(1:MAX_NUM_UE) = 0;

UE_HSDPA_rxpower(1:MAX_NUM_BS,1:MAX_NUM_UE) = 0;
SINR_HSDPA(1:MAX_NUM_BS,1:MAX_NUM_UE) = 0;
SINR_HSDPA_dB(1:MAX_NUM_BS,1:MAX_NUM_UE) = 0;

UE_AP_rxpower(1:MAX_NUM_AP,1:MAX_NUM_UE) = 0;
SINR_AP(1:MAX_NUM_AP,1:MAX_NUM_UE) = 0;
SINR_AP_dB(1:MAX_NUM_AP,1:MAX_NUM_UE) = 0;

BS_BitRate_DL(1:MAX_NUM_ALL,1:END_TIME) = 0; %
BS_Throughput_DL(1:MAX_NUM_ALL,1:END_TIME) = 0; % BS throghput every second
BS_Utilization_DL(1:MAX_NUM_ALL,1:END_TIME) = 0;
BS_Throughput_DL_Avg(1:MAX_NUM_ALL) = 0;
BS_P_Blocking(1:MAX_NUM_ALL) = 0;

AP_txpower(1:MAX_NUM_AP) = 0.1;

UE_Throughput_DL(1:MAX_NUM_UE,1:END_TIME) = 0;  %the real traffic at each user, as BitRate is the attempted/request traffic by the UE
UE_Cost(1:MAX_NUM_UE,1:END_TIME) = 0; 


%handover thresholds initialization

Th_add(1:MAX_NUM_ALL)		= 0;	%add margin
Th_drop(1:MAX_NUM_ALL)		= 0;	%drop margin
Th_rep(1:MAX_NUM_ALL)		= 0;	%replacement Hysteresis

Th_add_UE(1:MAX_NUM_UE)		= 0;	%add margin
Th_drop_UE(1:MAX_NUM_UE)	= 0;	%drop margin
Th_rep_UE(1:MAX_NUM_UE)		= 0;	%replacement Hysteresis


ActiveSet(1:MAX_NUM_UE, 1:4) = 0;
ActiveSet_Throughput(1:MAX_NUM_UE, 1:4) = 0;
Drop_Timer(1:MAX_NUM_UE,1:MAX_NUM_ALL)= 0;   %Time to trigger drop
Add_Timer(1:MAX_NUM_UE,1:MAX_NUM_ALL) = 0;   %Time to trigger add
Rep_Timer(1:MAX_NUM_UE,1:MAX_NUM_ALL) = 0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% start simulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for t=1:END_TIME

%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Downlink inteference and load factor
    % Calculated from power measurements left from (t-1)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %initialize downlink dedicated channel (DCH) tx power for each BS
    if t==1
        for UE=1:MAX_NUM_UE
            [i,j]=min(PathLoss(:,UE,t));
            ActiveSet(UE,1)= j;
            if (BitRate_DL(UE,1) == RATE_1) || (BitRate_DL(UE,1) == RATE_2)
                UE_Throughput_DL(UE,1) = BitRate_DL(UE,1); %for t=1, throughput equal to bitrate
            end
        end
    end

    % Downlink Load Factor
    BS_txpower = BS_HSDPA_txpower + ALPHA*(BS_Pilot_txpower + BS_Common_txpower); %row vector(1:11), BS total tx power = sum(traffic channel power)+pilot channel power

    % Downlink total interferences
    for UE=1:MAX_NUM_UE
        UE_total_rxpower(UE) = sum(BS_txpower'./(10.^(PathLoss(:,UE,t)/10)));
        UE_total_rxpower_AP(UE) = sum(AP_txpower'./((10.^(PathLoss_AP(:,UE,t)/10))+Pn_AP));
    end


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % cell selection and handover
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    for UE=1:MAX_NUM_UE

        UE_HSDPA_rxpower(:,UE) = BS_HSDPA_txpower'./(10.^(PathLoss(:,UE,t)/10));
        SINR_HSDPA(:,UE) = UE_HSDPA_rxpower(:,UE)/UE_total_rxpower(UE);
        SINR_HSDPA_dB(:,UE) = 10*log10(UE_HSDPA_rxpower(:,UE)/UE_total_rxpower(UE));

        UE_AP_rxpower(:,UE) = AP_txpower'./(10.^(PathLoss_AP(:,UE,t)/10));
        SINR_AP(:,UE) = func_sinr(UE_AP_rxpower(:,UE)/UE_total_rxpower_AP(UE));
        SINR_AP_dB(:,UE) = 10*log10(UE_AP_rxpower(:,UE)/UE_total_rxpower(UE));

        SINR_ALL = [SINR_HSDPA;SINR_AP];
        SINR_ALL_dB = [SINR_HSDPA_dB;SINR_AP_dB];
    end


    for UE=1:MAX_NUM_UE
        
    
if Handover_Type == 6 %adaptive_cost_utilization with b
    if BitRate_DL(UE,t) == 0
        [Best_Cell_Ec_Io,Best_Cell] = max(SINR_ALL(:,UE));
        ActiveSet(UE,1) = Best_Cell;
        ActiveSet(UE,2:4) = 0;
        ActiveSet_Throughput(UE,:) = 0;
        UE_Throughput_DL(UE,t) = 0;
    else %input of BitRate cannot be Zero
        if t==1 %utilization not avaiable yet
            ActiveSet(UE,1) = func_cell_selection_by_cost(SINR_ALL(:,UE),BitRate_DL(UE,t));
            ActiveSet_Throughput(UE,1) = BitRate_DL(UE,t);
        else
            [ActiveSet(UE,:),ActiveSet_Throughput(UE,:)] = func_cell_selection_soft(SINR_ALL(:,UE),BitRate_DL(UE,t), BS_Utilization_DL(:,t));
        end
        UE_Throughput_DL(UE,t) = sum(ActiveSet_Throughput(UE,:));
        for i=1:4 %active set of 4
            if ActiveSet(UE,i)~=0
                BS_Throughput_DL(ActiveSet(UE,i),t) = BS_Throughput_DL(ActiveSet(UE,i),t) + ActiveSet_Throughput(UE,i);
                BS_Utilization_DL(ActiveSet(UE,i),t) = func_utilization(ActiveSet(UE,i), BS_Throughput_DL(ActiveSet(UE,i),t));
            end
        end

    end
    
end
          
    end


    ActiveSet_ALL(:,:,t) = ActiveSet; %ActiveSet(UE,1:2,t)
    ActiveSet_Throughput_ALL(:,:,t) = ActiveSet_Throughput; 
    
end


% throughput of each cell for each t
for t=1:END_TIME
	for UE=1:MAX_NUM_UE
		for i=1:4 %active set of 4
			if ActiveSet_ALL(UE,i,t)~=0              
                UE_Cost(UE,t) = UE_Cost(UE,t) + func_cost(ActiveSet_ALL(UE,i,t)) * ActiveSet_Throughput_ALL(UE,i,t);
			end
		end
	end
end

Avg_BS_Throughput_DL = mean(mean(BS_Throughput_DL(1:MAX_NUM_BS,:)'));
Avg_AP_Throughput_DL = mean(mean(BS_Throughput_DL((MAX_NUM_BS+1):MAX_NUM_ALL,:)'));
Avg_Sys_Throughput_DL = mean(mean(BS_Throughput_DL'));
Avg_Sys_Blocking_DL = (sum(sum(BitRate_DL')) - sum(sum(BS_Throughput_DL')))/sum(sum(BitRate_DL'));
Avg_UE_Cost = mean(sum((UE_Cost)')./(sum(UE_Throughput_DL')+1e-100));

Avg_BS_Utilization_DL = mean(mean(BS_Utilization_DL(1:MAX_NUM_BS,:)'));
Avg_AP_Utilization_DL = mean(mean(BS_Utilization_DL((MAX_NUM_BS+1):MAX_NUM_ALL,:)'));
Avg_Sys_Utilization_DL = mean(mean(BS_Utilization_DL'));

